#! /usr/local/bin/rexx

/* BSF_JavaSwingFileDialog.rex */
  call SysCls
  frame = .bsf~new('javax.swing.JFrame','Frame')
  fchooser = .bsf~new('javax.swing.JFileChooser')

  fchooser~setCurrentDirectory( .bsf~new("java.io.File", ".") )

  -- general on the patterns used (cf. <java.util.regex.Pattern>)
  -- '^' symbol for begin of line
  -- '$' symbol for end of line
  -- '.' (dot) any character
  -- '?' previous character (expression) can occur 0 or at most one time
  -- '*' previous character (expression) can occur 0 or multiple times
  -- '+' previous character (expression) can occur 1 or multiple times
  -- '(' and ')' allows to group character sequences/expressions

  .bsf~bsf.import('org.oorexx.misc.RgfFilter', 'RgfFilter')  -- import Java class into ooRexx

      -- must end with 'bmp' or 'gif' in lower, mixed or upper case;
      -- '$' is the symbol in regular expressions for end-of-line
  filter=.rgfFilter~new('*.bmp;*.gif')          -- create a new filter
  filter~setPattern(".*\.([bB][mM][pP]|[gG][iI][fF])$")
  fchooser~setFileFilter(filter)                -- set the filter to fileDialog

      -- must end with '.rex' or '.rexx' in lower, mixed or upper
      -- '$' is the symbol in regular expressions for end-of-line
  filter=.rgfFilter~new('*.rex;*.rexx')         -- create a new filter
  filter~setPattern(".*\.[rR][eE][xX][xX]?$")
  fchooser~setFileFilter(filter)                -- set the filter to fileDialog

      -- must end exactly with '.java'
      -- '$' is the symbol in regular expressions for end-of-line
  filter=.rgfFilter~new('*.java')               -- create a new filter
  filter~setPattern(".*\.java$")
  fchooser~setFileFilter(filter)                -- set the filter to fileDialog

      -- must end with 'rex' or 'rex[x]' in lower, mixed or upper case or with 'java' in lower case
      -- '$' is the symbol in regular expressions for end-of-line
  filter=.rgfFilter~new('*.rex;*.rexx;*.java')       -- create a new filter
  filter~setPattern(".*\.([rR][eE][xX][xX]?|java)$")
  fchooser~setFileFilter(filter)                -- set the filter to fileDialog

  myfile = fchooser~showOpenDialog(frame)       -- now show and execute the dialog
  if myfile = 0 then
      do
        say 'Fully Qualified File =' fchooser~getSelectedFile~getPath
        say 'Just File Name       =' fchooser~getSelectedFile~getName
     end
  else
     say 'You Clicked Cancel'

::requires bsf.cls

