/* testing different versions of loading the JVM */

/* signal on any only on Object Rexx available */
signal on error   name any
signal on failure name any
signal on syntax  name any


cp=value("CLASSPATH",,"ENVIRONMENT")      /* get value of classpath */
fun="// heyohh, this 'classpath' is from the test string \\"

inv.=""        /* default to empty string */
i=0
i=i+1;               inv.i.ap="Append"       /* "1": works */
i=i+1;               inv.i.ap="Prepend"      /* "2": works */
i=i+1;                                       /* "3": works */
i=i+1; inv.i.cp=fun; inv.i.ap="Append"       /* "4": does NOT work */
i=i+1; inv.i.cp=fun; inv.i.ap="Prepend"      /* "5": does NOT work */
inv.0=i     /* save number of elements */

parse arg idx
if arg()>0 then say "received 'idx'-argument: ["idx"]"
if \ datatype(idx, "whole") then idx=1

if rxFuncQuery("BSF") then
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs
end

if BSFInvokedBy()=1 then
do
   say "This program must not be run via Java as it tries to test the loading of Java..."
   exit -1
end


if idx<1 | idx>inv.0 then
do
   say "idx=["idx"], inv.i=["inv.0"], hence loading the JVM without any parameters (= default initialisation)"
   call BsfLoadJava      /* use default initialisation */
end
else
do
   say "loading JVM: idx=["idx"], inv."idx".ap=["inv.idx.ap"], inv."idx".cp=["inv.idx.cp"]"
   call BsfLoadJava inv.idx.cp , inv.idx.ap     /* load the JVM */
end

   /* 'Class.class' is pre-registered for Rexx, cf. docs */
system=bsf('invoke', 'Class.class', 'forName', 'java.lang.System')

say "Java version:" bsf('invoke', system, "getProperty", "java.version")  /* get the Java version */
exit

any:
   aRc=rc
   aResult=result
   aSigl=sigl
   say condition("c")
   say "rc="aRc "result="aResult "sigl="aSigl "line=["sourceline(aSigl)"]"
   exit -1

